-- CombatLootCount 1.0 by Andromerius (pongo2002@gmail.com) 2024

-- Create Ace3 Addon.
CLC = LibStub('AceAddon-3.0'):NewAddon('CombatLootCount', 'AceConsole-3.0', 'AceHook-3.0', 'AceEvent-3.0');

-- LibSharedMedia-3.0
LSM = LibStub('LibSharedMedia-3.0');

function CLC:OnInitialize()

    LSM:Register(LSM.MediaType.FONT, 'CombatLootCount Font', [[Interface\AddOns\CombatLootCount\media\font.ttf]]);

end

if CombatLootCountDBC == nil then
    CombatLootCountDBC = {
		loot = "enable",
		combat = "enable",
		bags = {}
    }
end

if CombatLootCountDBC.loot == nil then
	CombatLootCountDBC.loot = "enable"
end

if CombatLootCountDBC.bags == nil then
    CombatLootCountDBC.bags = {}
end

if CombatLootCountDBC.combat == nil then
	CombatLootCountDBC.combat = "enable"
end

-- Setup slash command
SLASH_CLC1 = '/clc'

-- Create a frame to run our code when the game finishes loading
local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("PLAYER_REGEN_DISABLED")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("UNIT_ENTERED_VEHICLE")
frame:RegisterEvent("UNIT_EXITED_VEHICLE")
frame:RegisterEvent("PLAYER_CONTROL_LOST")
frame:RegisterEvent("PLAYER_CONTROL_GAINED")
frame:RegisterEvent("PLAYER_LEVEL_UP")
frame:RegisterEvent("PLAYER_XP_UPDATE")
frame:RegisterEvent("UNIT_AURA")
frame:RegisterEvent("LOOT_CLOSED")
frame:RegisterEvent("BAG_UPDATE")
frame:RegisterEvent("MERCHANT_CLOSED")
frame:RegisterUnitEvent("UNIT_HEALTH", "target")
frame:RegisterUnitEvent("UNIT_HEALTH", "player")
frame:RegisterUnitEvent("UNIT_POWER_UPDATE", "player")
frame:RegisterUnitEvent("UNIT_POWER_UPDATE", "target")
frame:RegisterEvent("PLAYER_TARGET_CHANGED")
frame:RegisterUnitEvent("UNIT_MAXHEALTH", "target")
frame:RegisterUnitEvent("UNIT_MAXHEALTH", "player")
frame:RegisterEvent("ACTIONBAR_SHOWGRID")
frame:RegisterEvent("ACTIONBAR_HIDEGRID")
frame:RegisterEvent("UNIT_PET")
frame:RegisterUnitEvent("UNIT_EXITED_VEHICLE", "player")
frame:RegisterEvent("PET_BAR_UPDATE")
frame:RegisterEvent("UNIT_HEALTH")
frame:RegisterEvent("PLAYER_TARGET_CHANGED")

local startTime

frame:SetScript("OnEvent", function(self, event, unit, ...)
-- print("Event fired: " .. event)

if CombatLootCountDBC.loot == nil then
    CombatLootCountDBC.loot = "enable"
end

if CombatLootCountDBC.bags == nil then
    CombatLootCountDBC.bags = {}
end

if CombatLootCountDBC.combat == nil then
    CombatLootCountDBC.combat = {}
end

    if event == "PLAYER_LOGIN" then
        print("|cFFFF0000CombatLootCount: ADDON LOADED! Please report any bugs.|r")
		print("|cFF88AAFFCombatLootCount: Loot messages off/on: /clc loot disable/enable.|r")
		print("|cFF88AAFFCombatLootCount: Combat timer off/on: /clc combat disable/enable.|r")
    end
	
-- Combat timer
local function combat_timer()
-- Combat start and end msg and timer
    if event == "PLAYER_REGEN_DISABLED" then
        startTime = GetTime()
        print("Combat started!")
		end
	if event == "PLAYER_REGEN_ENABLED" and startTime then
        local endTime = GetTime()
        local elapsedTime = endTime - startTime

        startTime = nil -- Reset the start time for the next combat

        local minutes = math.floor(elapsedTime / 60)
        local seconds = math.floor(elapsedTime % 60)

        local timeMessage

        if minutes > 0 then
            timeMessage = string.format("Combat ended after %d minutes and %d seconds.", minutes, seconds)
        else
            timeMessage = string.format("Combat ended after %d seconds.", seconds)
        end

        print(timeMessage)
    end
end

-- Undress Model
-- UNDRESS
-- Add undress button to dressup model window.
if not IsAddOnLoaded("Undressed") then

-- Create a separate frame to contain the button
local buttonFrame = CreateFrame("Frame", "UndressedButtonFrame", DressUpFrame)
buttonFrame:SetAllPoints(DressUpFrame)

-- Create the button within the separate frame
Undressed = CreateFrame("Button", "UndressedButton", buttonFrame, "UIPanelButtonTemplate")
Undressed:SetPoint("BOTTOMRIGHT", DressUpFrameResetButton, "BOTTOMLEFT", 0, 0)
Undressed:SetSize(60, 22)
Undressed:SetText("Undress")
Undressed:Raise()

Undressed:SetScript("OnClick", function(self)
    for i, child in ipairs({DressUpFrame:GetChildren()}) do
        if child:GetObjectType() == "DressUpModel" then
            child:Undress()
            break
        end
    end
end)
end

if (event == "PLAYER_REGEN_DISABLED" or event == "PLAYER_REGEN_ENABLED") and CombatLootCountDBC.combat == "enable" then
combat_timer()
end

function SlashCmdList.CLC(msg, editbox)
    local command, rest = msg:match("^(%S*)%s*(.-)$");
	
	if command:lower() == "loot" then
		if rest:lower() == "enable" then
			print("|cFFFF0000CombatLootCount: Loot messages enabled, please type /reload and press enter in your chat!|r")
			CombatLootCountDBC.loot = "enable"
			
		elseif rest:lower() == "disable" then
			print("|cFFFF0000CombatLootCount: Loot messages disabled, please type /reload and press enter in your chat!|r")
			CombatLootCountDBC.loot = "disable"
end
end

	if command:lower() == "combat" then
		if rest:lower() == "enable" then
			print("|cFFFF0000CombatLootCount: Combat timer enabled, please type /reload and press enter in your chat!|r")
			CombatLootCountDBC.combat = "enable"
			
		elseif rest:lower() == "disable" then
			print("|cFFFF0000CombatLootCount: Combat timer disabled, please type /reload and press enter in your chat!|r")
			CombatLootCountDBC.combat = "disable"
end
end
end


-- Loot Counts

if CombatLootCountDBC.loot == "enable" then

local function scanPlayerBags(printOutput)


    local previousCounts = {}  -- Store previous item counts from saved variables
    local currentCounts = {}   -- Store current item counts from the bag scan

    -- Copy the item counts from saved variables to previousCounts
    if CombatLootCountDBC.bags then
        for itemID, count in pairs(CombatLootCountDBC.bags) do
            previousCounts[itemID] = count
        end
    end

    -- Scan the bags and update currentCounts
    local itemCounts = {}
    for bag = 0, 4 do
        local numSlots = C_Container.GetContainerNumSlots(bag)
        for slot = 1, numSlots do
            local containerInfo = C_Container.GetContainerItemInfo(bag, slot)
            if containerInfo then
                local itemID = containerInfo.itemID
                local count = containerInfo.stackCount
                if not itemCounts[itemID] then itemCounts[itemID] = 0 end
                itemCounts[itemID] = itemCounts[itemID] + count
            end
        end
    end

    -- Update currentCounts with the item counts from the bag scan
    for itemID, count in pairs(itemCounts) do
        currentCounts[itemID] = count
    end

    -- Compare currentCounts with previousCounts and output loot messages
    for itemID, currentCount in pairs(currentCounts) do
        local previousCount = previousCounts[itemID]
        local change = currentCount - (previousCount or 0)
        if change > 0 and printOutput then
            local itemName, itemLink = GetItemInfo(itemID)
            print("|cFFFFFF00You looted ".. itemLink .." x" ..change ..", you now have ".. currentCount .." in your bags.")
        end
    end

    -- Update the saved variables with the new item counts
    CombatLootCountDBC.bags = currentCounts
end

local function delayedScanPlayerBags()
    C_Timer.After(1, function()
        scanPlayerBags(true)  -- Scan the bags and print loot messages
    end)
end

    if event == "LOOT_CLOSED" then
        delayedScanPlayerBags()  -- Delayed bag scan after loot is closed
    elseif event == "PLAYER_ENTERING_WORLD" then
        scanPlayerBags(false)  -- Initial bag scan without printing loot messages
    end
	
	    if event == "MERCHANT_CLOSED" then
        scanPlayerBags(false)  -- Bag scan after the player closes the vendor window
    end

    if event == "LOOT_CLOSED" then
        delayedScanPlayerBags()  -- Delayed bag scan after loot is closed
    elseif event == "PLAYER_ENTERING_WORLD" then
        scanPlayerBags(false)   -- Initial bag scan without printing loot messages
    elseif event == "MERCHANT_CLOSED" then
        scanPlayerBags(false)   -- Bag scan after the player closes the vendor window
    end

end

end)
